# Экспорт результатов

**BenchmarkOneScript** позволяет сохранить результаты выполнения бенчмарков в различных форматах. По умолчанию файлы с результатами генерируются в каталоге _./BenchmarkArtifacts_ относительно текущей рабочей директории.

### Настройка каталога артефактов

Каталог для сохранения результатов можно изменить двумя способами:

1. Через аннотацию в коде бенчмарка:

```bsl
&КаталогАртефактов("path/to/artifacts")
```

2. Программно с использованием API конфигурации:

```bsl
Конфигурация.УстановитьКаталогАртефактов("path/to/artifacts")
```

### Аннотации экспортеров

```bsl
&ЭкспортMarkdown
&ЭкспортJson
&ЭкспортXml
&ЭкспортHtml
Процедура ПриСозданииОбъекта()
```

### API

```bsl
// Добавление экспортера (например, для JSON)
Конфигурация.ДобавитьЭкспортер(ЭкспортерыРезультатовБенчмарков.Json);
//                             ЭкспортерыРезультатовБенчмарков.Xml
//                             ЭкспортерыРезультатовБенчмарков.Html
//                             ЭкспортерыРезультатовБенчмарков.Markdown

// Получение списка экспортеров
Экспортеры = Конфигурация.Экспортеры();

// Сброс всех экспортеров
Конфигурация.УдалитьЭкспортеры();
```

### Пример

```bsl
&ЭкспортMarkdown
&ЭкспортJson
&ЭкспортXml
&ЭкспортHtml
&КаталогАртефактов("./АртефкатыЗапускаБенчмарков")
Процедура ПриСозданииОбъекта()
КонецПроцедуры

&Бенчмарк
Процедура Бенчмарк() Экспорт
	Приостановить(100);
КонецПроцедуры
```

### Вывод

```
BenchmarkOneScript v0.3.1, OneScript v2.0.0.567-rc7-29039316, Microsoft Windows NT 10.0.20348.0 \
Intel Core i7-8700 CPU 3.20GHz (Max: 3.19GHz) (Coffee Lake), 1 CPU, 12 logical and 6 physical cores

| Method   |     Mean |   StdErr |   StdDev |  Op/s |
|----------|---------:|---------:|---------:|------:|
| Бенчмарк | 100.7 ms | 30.38 us | 117.7 us | 9.934 |

// Легенда
Mean   : Арифметическое среднее всех измерений
StdErr : Стандартная ошибка всех измерений
StdDev : Стандартное отклонение всех измерений
Op/s   : Операций в секунду
1 ms   : 1 Миллисекунда
1 us   : 1 Микросекунда

// Артефакты
C:\myapp\АртефкатыЗапускаБенчмарков\ИмяКласса-report.html
C:\myapp\АртефкатыЗапускаБенчмарков\ИмяКласса-report.json
C:\myapp\АртефкатыЗапускаБенчмарков\ИмяКласса-report.md
C:\myapp\АртефкатыЗапускаБенчмарков\ИмяКласса-report.xml
```